unit UFormMain;

{$mode delphi}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  ExtCtrls, UEngine;

type

  { TFormMain }

  TFormMain = class(TForm)
    PaintBox1: TPaintBox;
    Timer1: TTimer;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: char);
    procedure FormShow(Sender: TObject);
    procedure PaintBox1Click(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { private declarations }
  public
    Engine: TEngine;
    procedure Repaint;
  end;

var
  FormMain: TFormMain;

implementation

{$R *.lfm}

{ TFormMain }

procedure TFormMain.FormCreate(Sender: TObject);
begin
  Engine := TEngine.Create;
end;

procedure TFormMain.FormDestroy(Sender: TObject);
begin
  Engine.Free;
end;

procedure TFormMain.FormKeyPress(Sender: TObject; var Key: char);
begin
  if (Key = #32) then begin
    if Engine.State = gsRunning then Engine.State := gsPaused
    else if Engine.State = gsPaused then Engine.State := gsRunning;
  end;
end;

procedure TFormMain.FormShow(Sender: TObject);
begin
  Randomize;
  Engine.View.Size := Point(PaintBox1.Width, PaintBox1.Height);
  Engine.Map.Size := Engine.View.Size;
  Engine.Reset;
end;

procedure TFormMain.PaintBox1Click(Sender: TObject);
begin

end;

procedure TFormMain.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Engine.MouseDown(Button, Point(X, Y));
end;

procedure TFormMain.PaintBox1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  Engine.MouseMove(Point(X, Y));
end;

procedure TFormMain.PaintBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  Engine.MouseUp(Button, Point(X, Y));
end;

procedure TFormMain.PaintBox1Paint(Sender: TObject);
begin
  Engine.Paint(PaintBox1.Canvas);
end;

procedure TFormMain.Timer1Timer(Sender: TObject);
begin
  PaintBox1.Repaint;
  Engine.Tick;
end;

procedure TFormMain.Repaint;
begin

end;

end.

